---
name: Bug report
about: Report problems and unexpected behavior

---

<!--

First of all, please read https://www.chiark.greenend.org.uk/~sgtatham/bugs.html.

If you don't want to read, it's up to you. But don't waste your time continue reporting.

The issue will be closed without any explanation if it does not satisfy any of following requirements:

1. Please speak English
2. Please do not end your title with a question mark or period.
3. Please take a moment to search and make sure the issue doesn't already exist.
4. Please give all relevant information below for bug reports; incomplete details are considered invalid report.

-->

**Describe the bug**
<!-- A clear and concise description of what the bug is -->

**Gogs version or commit**
<!-- The version number or the commit SHA of the Gogs instance you use -->

**Git version**

```
$ git version

```

**Operating system**
<!-- The name and version of your operating system -->

**Database**
<!-- The database and version you use -->

**To Reproduce**
Steps to reproduce the behavior:
1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

**Can you reproduce the bug at https://try.gogs.io?**
<!-- If yes, please provide the example URL; if no, please explain why -->

**Expected behavior**
<!-- A clear and concise description of what you expected to happen -->

**Actual behavior**
<!-- A clear and concise description of what you see instead -->

**Screenshots**
<!-- If applicable, add screenshots to help explain your problem -->

**Additional context**
<!-- Please include any error logs found in `log/gogs.log` -->
